<template>
  <div>
    Пошук за
    <select v-model="filter">
      <option value="1" selected>Назва</option>
      <option value="2">Адреса</option>
      <option value="3">Спеціалізація</option>
      <option value="4">Номер телефону</option>
      <option value="5">Час роботи</option>
    </select>
    <input v-model="searchTerm" type="text" placeholder="Search" />
    <br /><br />
    <button @click="$router.push('/add')">Додати</button>
    <hr />
    <company-component
      v-for="company in filteredItems"
      :company="company"
      :key="company"
    ></company-component>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import CompanyComponent from "@/components/CompanyComponent.vue";
export default {
  data() {
    return {
      searchTerm: "",
      filter: "",
    };
  },
  components: {
    CompanyComponent,
  },
  computed: {
    ...mapGetters(["getItemsList"]),
    filteredItems() {
      if (this.filter == "1") {
        return this.getItemsList.filter((object) => {
          return object.name
            .toLowerCase()
            .includes(this.searchTerm.toLowerCase());
        });
      } else if (this.filter == "2") {
        return this.getItemsList.filter((object) => {
          return String(object.address).includes(this.searchTerm);
        });
      } else if (this.filter == "3") {
        return this.getItemsList.filter((object) => {
          return String(object.specialization).includes(this.searchTerm);
        });
      } else if (this.filter == "4") {
        return this.getItemsList.filter((object) => {
          return String(object.phone).includes(this.searchTerm);
        });
      } else if (this.filter == "5") {
        return this.getItemsList.filter((object) => {
          return String(object.workTime).includes(this.searchTerm);
        });
      } else {
        return this.getItemsList;
      }
    },
  },
  methods: {
    ...mapActions(["loadList"]),
  },
  created() {
    this.loadList();
  },
};
</script>
